Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVDecoder.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVDecoder.cs	(revision 6260)
@@ -50,11 +50,11 @@
     }
 
+    #region Private Members
     [Storable]
     private Schedule resultingSchedule;
 
-    public PRVDecoder()
-      : base() {
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-    }
+    [Storable]
+    private ItemList<JSSPJob> jobs;
+    #endregion
 
     #region Priority Rules
@@ -67,8 +67,8 @@
     //earliest start time
     private JSSPTask ESTRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       double currentEST = double.MaxValue;
       foreach (JSSPTask t in tasks) {
-        double est = ComputeEarliestStartTime(t).Value;
+        double est = resultingSchedule.ComputeEarliestStartTime(t, jobs[t.JobNr.Value]);
         if (est < currentEST) {
           currentEST = est;
@@ -81,5 +81,5 @@
     //shortest processingtime
     private JSSPTask SPTRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       foreach (JSSPTask t in tasks) {
         if (t.Duration.Value < currentResult.Duration.Value)
@@ -91,5 +91,5 @@
     //longest processing time    
     private JSSPTask LPTRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       foreach (JSSPTask t in tasks) {
         if (t.Duration.Value > currentResult.Duration.Value)
@@ -101,9 +101,9 @@
     //most work remaining
     private JSSPTask MWRRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       double currentLargestRemainingProcessingTime = 0;
       foreach (JSSPTask t in tasks) {
         double remainingProcessingTime = 0;
-        foreach (JSSPTask jt in t.Job.Tasks) {
+        foreach (JSSPTask jt in jobs[t.JobNr.Value].Tasks) {
           if (!jt.IsScheduled.Value)
             remainingProcessingTime += jt.Duration.Value;
@@ -119,9 +119,9 @@
     //least work remaining
     private JSSPTask LWRRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       double currentSmallestRemainingProcessingTime = double.MaxValue;
       foreach (JSSPTask t in tasks) {
         double remainingProcessingTime = 0;
-        foreach (JSSPTask jt in t.Job.Tasks) {
+        foreach (JSSPTask jt in jobs[t.JobNr.Value].Tasks) {
           if (!jt.IsScheduled.Value)
             remainingProcessingTime += jt.Duration.Value;
@@ -137,9 +137,9 @@
     //most operations remaining
     private JSSPTask MORRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       int currentLargestNrOfRemainingTasks = 0;
       foreach (JSSPTask t in tasks) {
         int nrOfRemainingTasks = 0;
-        foreach (JSSPTask jt in t.Job.Tasks) {
+        foreach (JSSPTask jt in jobs[t.JobNr.Value].Tasks) {
           if (!jt.IsScheduled.Value)
             nrOfRemainingTasks++;
@@ -155,9 +155,9 @@
     //least operationsremaining
     private JSSPTask LORRule(ItemList<JSSPTask> tasks) {
-      JSSPTask currentResult = tasks[0];
+      JSSPTask currentResult = RandomRule(tasks);
       int currentSmallestNrOfRemainingTasks = int.MaxValue;
       foreach (JSSPTask t in tasks) {
         int nrOfRemainingTasks = 0;
-        foreach (JSSPTask jt in t.Job.Tasks) {
+        foreach (JSSPTask jt in jobs[t.JobNr.Value].Tasks) {
           if (!jt.IsScheduled.Value)
             nrOfRemainingTasks++;
@@ -185,5 +185,10 @@
     #endregion
 
-    private ItemList<JSSPTask> GetEarliestNotScheduledTasks(ItemList<JSSPJob> jobs) {
+    public PRVDecoder()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+    }
+
+    private ItemList<JSSPTask> GetEarliestNotScheduledTasks() {
       ItemList<JSSPTask> result = new ItemList<JSSPTask>();
       foreach (JSSPJob j in jobs) {
@@ -198,9 +203,9 @@
     }
     private JSSPTask GetTaskWithMinimalEC(ItemList<JSSPTask> earliestTasksList) {
-      DoubleValue minEct = new DoubleValue(Double.MaxValue);
+      double minEct = double.MaxValue;
       JSSPTask result = null;
       foreach (JSSPTask t in earliestTasksList) {
-        DoubleValue ect = ComputeEarliestCompletionTime(t);
-        if (ect.Value < minEct.Value) {
+        double ect = resultingSchedule.ComputeEarliestCompletionTime(t, jobs[t.JobNr.Value]);
+        if (ect < minEct) {
           result = t;
           minEct = ect;
@@ -211,9 +216,8 @@
     private ItemList<JSSPTask> GetConflictSetForTask(JSSPTask conflictedTask, ItemList<JSSPTask> earliestTasksList) {
       ItemList<JSSPTask> result = new ItemList<JSSPTask>();
-      DoubleValue conflictedCompletionTime = ComputeEarliestCompletionTime(conflictedTask);
-      //result.Add(conflictedTask);
+      double conflictedCompletionTime = resultingSchedule.ComputeEarliestCompletionTime(conflictedTask, jobs[conflictedTask.JobNr.Value]);
       foreach (JSSPTask t in earliestTasksList) {
         if (t.ResourceNr.Value == conflictedTask.ResourceNr.Value) {
-          if (ComputeEarliestStartTime(t).Value < conflictedCompletionTime.Value)
+          if (resultingSchedule.ComputeEarliestStartTime(t, jobs[t.JobNr.Value]) < conflictedCompletionTime)
             result.Add(t);
         }
@@ -240,27 +244,7 @@
       }  
     }
-    private DoubleValue ComputeEarliestStartTime(JSSPTask t) {
-      Resource affectedResource = resultingSchedule.Resources[t.ResourceNr.Value];
-
-      DoubleValue lastMachineEndTime = affectedResource.TotalDuration;
-      DoubleValue previousJoboperationEndTime = new DoubleValue(double.MinValue);
-      if (t.PreviousTask != null)
-        previousJoboperationEndTime = t.PreviousTask.EndTime;
-
-      return new DoubleValue(Math.Max(previousJoboperationEndTime.Value, lastMachineEndTime.Value));
-    }
-    private DoubleValue ComputeEarliestCompletionTime(JSSPTask t) {
-      return new DoubleValue(ComputeEarliestStartTime(t).Value + t.Duration.Value);
-    }
-    private void AddTaskToSchedule(JSSPTask selectedTask) {
-      Resource affectedResource = resultingSchedule.Resources[selectedTask.ResourceNr.Value];
-      selectedTask.StartTime = ComputeEarliestStartTime(selectedTask);
-      selectedTask.IsScheduled.Value = true;
-      affectedResource.Tasks.Add(selectedTask);
-    }
 
     public override Schedule CreateScheduleFromEncoding(PRVEncoding solution) {
-      PRVEncoding priorityRulesVector = solution;
-
+      jobs = (ItemList<JSSPJob>)Jobs.Clone();
       resultingSchedule = new Schedule(new IntValue(Jobs[0].Tasks.Count));
 
@@ -274,5 +258,5 @@
       //GT-Algorithm
       //STEP 0 - Compute a list of "earliest operations"
-      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks();
       int currentDecisionIndex = 0;
       while (earliestTasksList.Count > 0) {
@@ -284,11 +268,12 @@
 
         //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
-        JSSPTask selectedTask = SelectTaskFromConflictSet(conflictSet, priorityRulesVector [currentDecisionIndex++], solution.NrOfRules.Value);
+        JSSPTask selectedTask = SelectTaskFromConflictSet(conflictSet, solution [currentDecisionIndex++], solution.NrOfRules.Value);
 
         //STEP 4 - Adding the selected operation to the current schedule
-        AddTaskToSchedule(selectedTask);
+        selectedTask.IsScheduled.Value = true;
+        resultingSchedule.AddTask(selectedTask, jobs[selectedTask.JobNr.Value]);
 
         //STEP 5 - Back to STEP 1
-        earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+        earliestTasksList = GetEarliestNotScheduledTasks();
       }
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/PRVEncoding.cs	(revision 6260)
@@ -37,5 +37,5 @@
   [Item("Priority Rules Vector Encoding", "Represents a solution for a standard JobShop Scheduling Problem.")]
   [StorableClass]
-  public class PRVEncoding : IntegerVector, IJSSPEncoding{
+  public class PRVEncoding : IntegerVector, ISchedulingEncoding{
     [StorableConstructor]
     protected PRVEncoding(bool deserializing) : base(deserializing) { }
@@ -64,5 +64,5 @@
     public PRVEncoding (IntegerVector iv, IntValue nrOfRules) : base (iv.Length) {
       this.nrOfRules = (IntValue)nrOfRules.Clone();
-      foreach (int i in iv) {
+      for (int i = 0; i < iv.Length; i++) {
         this[i] = iv[i];
       }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluationAlgorithm.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluationAlgorithm.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluationAlgorithm.cs	(revision 6260)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix;
+using HeuristicLab.Optimization;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Evaluators {
+  [Item("Scheduling Evaluator", "Represents a general evaluator class for scheduling problems.")]
+  [StorableClass]
+  public class JSSPEvaluationAlgorithm : AlgorithmOperator, ISchedulingEvaluator {
+    [StorableConstructor]
+    protected JSSPEvaluationAlgorithm(bool deserializing) : base(deserializing) { }
+    protected JSSPEvaluationAlgorithm(JSSPEvaluationAlgorithm original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSSPEvaluationAlgorithm(this, cloner);
+    }
+
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get {
+        if (Parameters.ContainsKey("Quality"))
+          return (ILookupParameter<DoubleValue>)Parameters["Quality"];
+        else
+          return null;
+      }
+    }
+
+    public void InitializeOperatorGraph<T>(JSSPDecoder<T> decoder, JSSPEvaluator evaluator) where T: Item, ISchedulingEncoding{
+      OperatorGraph.InitialOperator = decoder;
+      decoder.Successor = evaluator;
+    }
+
+    public JSSPEvaluationAlgorithm()
+      : base() {
+        Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+        InitializeOperatorGraph<JSMEncoding>(new JSMDecoder(), new MakespanEvaluator());
+    }
+
+    public override IOperation Apply() {
+      return base.Apply();
+    }
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/JSSPEvaluator.cs	(revision 6260)
@@ -32,4 +32,5 @@
 using HeuristicLab.Problems.Scheduling.Encodings;
 using HeuristicLab.Operators;
+using HeuristicLab.Problems.Scheduling.Interfaces;
 
 
@@ -37,5 +38,5 @@
   [Item("JSSP Evaluator", "Represents a evaluator class for standard job shop scheduling problems.")]
   [StorableClass]
-  public abstract class JSSPEvaluator : JSSPOperator, ISingleObjectiveEvaluator {
+  public abstract class JSSPEvaluator : JSSPOperator, ISchedulingEvaluator {
     [StorableConstructor]
     protected JSSPEvaluator(bool deserializing) : base(deserializing) { }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MakespanEvaluator.cs	(revision 6260)
@@ -50,5 +50,5 @@
       foreach (Resource r in schedule.Resources) {
         if (r.TotalDuration.Value > quality.Value) {
-          quality = r.TotalDuration;
+          quality.Value = r.TotalDuration.Value;
         }
       }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6260)
@@ -52,5 +52,5 @@
     <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMJOXCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMCrossover.cs" />
-    <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMOrderCrossover.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMOXCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Crossovers\JSMSXXCrossover.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\JSMDecoder.cs" />
@@ -60,8 +60,16 @@
     <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMShiftChangeManipulator.cs" />
     <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMManipulator.cs" />
-    <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMInsertionManipulator.cs" />
+    <Compile Include="Encodings\JobSequenceMatrix\Manipulators\JSMSwapManipulator.cs" />
     <Compile Include="Encodings\JSSPCrossover.cs" />
     <Compile Include="Encodings\JSSPDecoder.cs" />
     <Compile Include="Encodings\JSSPEncodingTypes.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\Crossovers\PWRGOXCrossover.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\Crossovers\PWRCrossover.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\Crossovers\PWRPPXCrossover.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\Manipulators\PWRUniformOnePositionManipulator.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\Manipulators\PWRManipulator.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\PWRDecoder.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\PWREncoding.cs" />
+    <Compile Include="Encodings\PermutationWithRepetition\PWRRandomCreator.cs" />
     <Compile Include="Encodings\PriorityRulesVector\Crossovers\PRVSinglePointCrossover.cs" />
     <Compile Include="Encodings\PriorityRulesVector\Crossovers\PRVDiscreteCrossover.cs" />
@@ -69,5 +77,6 @@
     <Compile Include="Encodings\PriorityRulesVector\PRVEncoding.cs" />
     <Compile Include="Interfaces\IJSSPDecoder.cs" />
-    <Compile Include="Interfaces\IJSSPOperator.cs" />
+    <Compile Include="Interfaces\ISchedulingOperator.cs" />
+    <Compile Include="Interfaces\IPWROperator.cs" />
     <Compile Include="Interfaces\IPRVOperator.cs" />
     <Compile Include="Interfaces\IJSSPEncoding.cs" />
@@ -87,10 +96,9 @@
     <Compile Include="Resource.cs" />
     <Compile Include="Evaluators\JSSPEvaluator.cs" />
-    <Compile Include="Interfaces\IJSSPCreator.cs" />
     <Compile Include="JSSPJob.cs" />
     <Compile Include="JobShopSchedulingProblem.cs" />
     <Compile Include="JSSPTask.cs" />
     <Compile Include="Encodings\JSSPOperator.cs" />
-    <Compile Include="Evaluators\SchedulingEvaluator.cs" />
+    <Compile Include="Evaluators\JSSPEvaluationAlgorithm.cs" />
     <Compile Include="SchedulingProblem.cs" />
     <Compile Include="Plugin.cs" />
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPWROperator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPWROperator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IPWROperator.cs	(revision 6260)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  interface IPWROperator : IOperator {
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCrossover.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingCrossover.cs	(revision 6260)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Optimization;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingCrossover : ICrossover{
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingDecoder.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingDecoder.cs	(revision 6260)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingDecoder : IOperator {
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEncoding.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEncoding.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingEncoding.cs	(revision 6260)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingEncoding : IItem {
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingManipulator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingManipulator.cs	(revision 6260)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.Scheduling.Encodings;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingManipulator : IManipulator {
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingOperator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingOperator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/ISchedulingOperator.cs	(revision 6260)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface ISchedulingOperator : IOperator {
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPJob.cs	(revision 6260)
@@ -54,4 +54,11 @@
       return sb.ToString();
     }
+
+    internal JSSPTask GetPreviousTask(JSSPTask t) {
+      if (t.TaskNr.Value == 0)
+        return null;
+      else
+        return Tasks[t.TaskNr.Value - 1];
+    }
   }
 }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JSSPTask.cs	(revision 6260)
@@ -42,7 +42,5 @@
       this.TaskNr = cloner.Clone(original.TaskNr);
       this.IsScheduled = cloner.Clone(original.IsScheduled);
-      this.Job = cloner.Clone(original.Job);
-      this.PreviousTask = cloner.Clone(original.PreviousTask);
-      this.NextTask = cloner.Clone(original.NextTask);
+      this.JobNr = cloner.Clone (original.JobNr);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -61,9 +59,8 @@
       }
     }
-    public JSSPJob Job { get; set; }
-    public JSSPTask PreviousTask { get; set; }
-    public JSSPTask NextTask { get; set; }
+    public IntValue JobNr { get; set; }
 
-    public JSSPTask (IntValue taskNr, IntValue resNr, DoubleValue duration, JSSPJob j) : base () {
+
+    public JSSPTask (IntValue taskNr, IntValue resNr, DoubleValue duration, IntValue jobNr) : base () {
       Duration = duration;
       ResourceNr = resNr;
@@ -71,5 +68,11 @@
       StartTime = new DoubleValue(0);
       IsScheduled = new BoolValue(false);
-      Job = j;
+      JobNr = jobNr;
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[" + JobNr + "," + ResourceNr + "]");
+      return sb.ToString();
     }
   }
